<?php

namespace Modules\Jiesuan\Http\Controllers;

use Catch\Base\CatchController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Modules\User\Http\Controllers\UserTrait;

class JiesuanController extends CatchController
{
    use UserTrait;
    use ValidatesRequests;

    /**
     * 结算记录
     * @param Request $request
     */
    public function list(Request $request) {
        $jiesuanDateStartAt = $request->input('jiesuan_date_start_at');
        $jiesuanDateEndAt = $request->input('jiesuan_date_end_at');
        $isExport = $request->input('is_export', 0);
        $sql = DB::table('jiesuan_records')
            ->where([
                'company_uid' => $this->getLoginUserId(),
            ])->when($jiesuanDateStartAt, function ($query, $jiesuanDateStartAt) {
                return $query->where('jiesuan_date', '>=', $jiesuanDateStartAt);
            })
            ->when($jiesuanDateEndAt, function ($query, $jiesuanDateEndAt) {
                return $query->where('jiesuan_date', '<=', $jiesuanDateEndAt);
            })
            ->orderBy('jiesuan_date', 'desc')
            ->select('id', 'jiesuan_date', 'charge_money', 'tuikuan_money', 'share_rate', 'jiesuan_money');
        if($isExport) {
            $results = $sql->get();
        } else {
            $results = $sql->paginate($request->input('limit', 15));
        }

        foreach ($results as $item) {
            $item->share_rate .= '%';
        }
    }

    /**
     * 账户金额详情
     * @param Request $request
     */
    public function accountInfo(Request $request) {
        $company_uid = $this->getLoginUserId();
        $moneyInfo = DB::table('company_user_money')
            ->where('company_uid', $company_uid)
            ->select('total_income', 'total_dakuan', 'total_tuikuan', 'id')
            ->first();

        $tixian_money = DB::table('tixian_records')
            ->where('company_uid', $company_uid)
            ->whereIn('status', [1,3])
            ->sum('tixian_money');

        $moneyInfo->tixian_money = $tixian_money;
        $moneyInfo->yue_money = $moneyInfo->total_income - $moneyInfo->total_tuikuan - $moneyInfo->total_dakuan - $tixian_money;
        return $moneyInfo;
    }

    /**
     * 申请提现
     * @param Request $request
     */
    public function tixian(Request $request) {
        $this->validate($request, [
            'bank_card_id' => 'required',
            'tixian_money' => 'required|numeric|min:500'
        ]);
        $company_uid = $this->getLoginUserId();

//        DB::table('tixian_records')
//            ->insert()
    }

    /**
     * 提现记录
     * @param Request $request
     */
    public function listTixian(Request $request) {

    }
}
